/* From Stroustrup special ed. p750 */

/* Usage: 

  try{
    Assert<GeneralError>(!ASSERT::ERROR_CHECK||some_condition_that_must_be_true);
  }
  catch(GeneralError){
    std::cerr << "Error.\n";
    exit(-1);
  }

*/

#ifndef ASSERTION
#define ASSERTION


template<class X,class A> inline void Assert(A assertion)
{
  if(!assertion) throw X();
}

class GeneralError {};

/* Look at p199 of Stroustrup special ed. (internal linking) */
#ifndef NDEBUG
#warning "Debugging mode is turned on"
namespace ASSERT{
  constexpr bool ERROR_CHECK = true;
}
#else
namespace ASSERT{
  constexpr bool ERROR_CHECK = false;
}
#endif

#endif
