#include "parallel-print.hpp"

ParallelPrint::Mutex ParallelPrint::cout_mutex;
ParallelPrint::Mutex ParallelPrint::cerr_mutex;

void ParallelPrint::cout(const std::string& text)
{
  Mutex::scoped_lock lock(cout_mutex);
  std::cout << text;
}

void ParallelPrint::cerr(const std::string& text)
{
  Mutex::scoped_lock lock(cerr_mutex);
  std::cerr << text;
}
